#include <nds.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dswifi7.h>

#include "quake_ipc.h"

volatile unsigned int do_mp3 = 0;
volatile unsigned int decoder_stopped = 1;
volatile char track_name[100];

//#define USE_MP3
//#define USE_WIFI

//---------------------------------------------------------------------------------
void startSound(int sampleRate, const void* data, u32 bytes, u8 channel, u8 vol,  u8 pan, u8 format) {
//---------------------------------------------------------------------------------
	SCHANNEL_TIMER(channel)  = SOUND_FREQ(sampleRate);
	SCHANNEL_SOURCE(channel) = (u32)data;
	SCHANNEL_LENGTH(channel) = bytes >> 2 ;
	SCHANNEL_CR(channel)     = SCHANNEL_ENABLE | SOUND_ONE_SHOT | SOUND_VOL(vol) | SOUND_PAN(pan) | (format==1?SOUND_8BIT:SOUND_16BIT);
}


//---------------------------------------------------------------------------------
s32 getFreeSoundChannel() {
//---------------------------------------------------------------------------------
	int i;
	for (i=0; i<16; i++) {
		if ( (SCHANNEL_CR(i) & SCHANNEL_ENABLE) == 0 ) return i;
	}
	return -1;
}

extern "C" void ds_playsound(void *data, int length, int samplerate)
{
	s32 channel = getFreeSoundChannel();
	
	if (channel != -1)
		startSound(samplerate, data, length, channel, 127, 64, 0);
}

void stopAllSounds(void)
{
	int count;
	
	for (count = 0; count < 16; count++)
		SCHANNEL_CR(count) = 0;
}

int vcount;
touchPosition first,tempPos;

//---------------------------------------------------------------------------------
void VcountHandler() {
//---------------------------------------------------------------------------------
	static int lastbut = -1;
	
	uint16 but=0, x=0, y=0, xpx=0, ypx=0, z1=0, z2=0;

	but = REG_KEYXY;

	if (!( (but ^ lastbut) & (1<<6))) {
 
		tempPos = touchReadXY();

		if ( tempPos.x == 0 || tempPos.y == 0 ) {
			but |= (1 <<6);
			lastbut = but;
		} else {
			x = tempPos.x;
			y = tempPos.y;
			xpx = tempPos.px;
			ypx = tempPos.py;
			z1 = tempPos.z1;
			z2 = tempPos.z2;
		}
		
	} else {
		lastbut = but;
		but |= (1 <<6);
	}

	if ( vcount == 80 ) {
		first = tempPos;
	} else {
		if (	abs( xpx - first.px) > 10 || abs( ypx - first.py) > 10 ||
				(but & ( 1<<6)) ) {

			but |= (1 <<6);
			lastbut = but;

		} else { 	
			IPC->mailBusy = 1;
			IPC->touchX			= x;
			IPC->touchY			= y;
			IPC->touchXpx		= xpx;
			IPC->touchYpx		= ypx;
			IPC->touchZ1		= z1;
			IPC->touchZ2		= z2;
			IPC->mailBusy = 0;
		}
	}
	IPC->buttons		= but;
	vcount ^= (80 ^ 130);
	SetYtrigger(vcount);

}

int hblanks = 0;

void hblank_handler(void)
{
	hblanks++;
}



int compute_jump(int address, int jump_to)
{
	int bl_inst = 0xEA000000;
	int offset = jump_to - address;
	
	offset = offset >> 2;
	offset = offset - 2;
	offset = offset & 0xFFFFFF;
	
	int new_opcode = bl_inst | offset;
	
	return new_opcode;
}
//
//unsigned short compute_jump_thumb(int address, int jump_to)
//{
//	unsigned short bl_inst = 0xE000;
//	int offset = jump_to - address;
//	
//	offset = offset >> 1;
//	offset = offset - 1;
//	offset = offset & 2047;
//	
//	unsigned short new_opcode = bl_inst | offset;
//	
//	return new_opcode;
//}

extern "C" void *new_malloc(int size);
extern "C" int helix_main(int argc, char **argv);
extern "C" void helix_init(void);

int keepalive = 0;

void handle_ipc(void)
{
	keepalive++;
	if (keepalive > 96)
	{
//		ARM7_PRINTF("keepalive\n");
		keepalive = 0;
	}
	
	
	if (quake_ipc_9to7->message == 0xffffffff)
	{
//		ARM7_PRINTF("message type %d\n", quake_ipc_9to7->message_type);
		
		switch (quake_ipc_9to7->message_type)
		{
			case kPrintMessage:
			{
				ARM7_PRINTF((char *)quake_ipc_9to7_buf);
				break;
			}
			case kInit:
			{
//				*(unsigned int *)malloc = compute_jump((unsigned int)malloc, (unsigned int)new_malloc);
				
				quake_ipc_9to7->message = 0;
				
				while (quake_ipc_9to7->message == 0);
				
				quake_ipc_9to7_buf = (unsigned char *)quake_ipc_9to7->message;
				
				quake_ipc_9to7->message = 0xffffffff;
				
				while (quake_ipc_9to7->message == 0xffffffff);
				
				quake_ipc_7to9_buf = (unsigned char *)quake_ipc_9to7->message;
				
				ARM7_PRINT("done\n");
				ARM7_PRINTF("7: 9->7 %08x 7->9 %08x\n", quake_ipc_9to7_buf, quake_ipc_7to9_buf);
				
				quake_ipc_9to7->message = 0xffffffff;
#ifdef USE_MP3				
				helix_init();
#endif
				
				break;
				
			}
			case kStopAllSounds:
			{
				ARM7_PRINT("Stopping sounds...");
				stopAllSounds();
				ARM7_PRINT("...done\n");
				
				break;
			}
			case kPlayMP3:
			{
				ARM7_PRINT("arm7 mp3 start msg\ntrack: ");
				memcpy((void *)track_name, (void *)quake_ipc_9to7_buf, 100);
				ARM7_PRINT((char *)track_name);
				ARM7_PRINT("\n");
				do_mp3 = 1;
				
				break;
			}
			case kStopMP3:
			{
				ARM7_PRINT("arm7 mp3 stop msg\n");
				do_mp3 = 0;
				
				break;
			}
			default:
			{
				ARM7_PRINT("some other message, ");
				ARM7_PRINT_NUMBER(quake_ipc_9to7->message_type);
				ARM7_PRINT("\n");
				break;
			}
		}
		quake_ipc_9to7->message = 0;
	}
}

//---------------------------------------------------------------------------------
void VblankHandler(void) {
//---------------------------------------------------------------------------------

	u32 i;


	//sound code  :)
	TransferSound *snd = IPC->soundData;
	IPC->soundData = 0;

	if (0 != snd) {

		for (i=0; i<snd->count; i++) {
			s32 chan = getFreeSoundChannel();

			if (chan >= 0) {
				startSound(snd->data[i].rate, snd->data[i].data, snd->data[i].len, chan, snd->data[i].vol, snd->data[i].pan, snd->data[i].format);
			}
		}
	}
	
#ifdef USE_WIFI
	Wifi_Update(); // update wireless in vblank
#endif
	handle_ipc();
}

// callback to allow wifi library to notify arm9
void arm7_synctoarm9() { // send fifo message
   REG_IPC_FIFO_TX = 0x87654321;
}
// interrupt handler to allow incoming notifications from arm9
void arm7_fifo() { // check incoming fifo messages
   u32 msg = REG_IPC_FIFO_RX;
#ifdef USE_WIFI
   if(msg==0x87654321) Wifi_Sync();
#endif
}

//---------------------------------------------------------------------------------
int main(int argc, char ** argv) {
//---------------------------------------------------------------------------------
	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR; // enable & prepare fifo asap
	// Reset the clock if needed
	rtcReset();

	//enable sound
	powerON(POWER_SOUND);
	SOUND_CR = SOUND_ENABLE | SOUND_VOL(0x7F);
	IPC->soundData = 0;
	IPC->mailBusy = 0;

	irqInit();
	irqSet(IRQ_VBLANK, VblankHandler);
	SetYtrigger(80);
	vcount = 80;
	irqSet(IRQ_VCOUNT, VcountHandler);
	irqEnable(IRQ_VBLANK);
	irqEnable(IRQ_VCOUNT);
	
	irqSet(IRQ_HBLANK, hblank_handler);
	irqEnable(IRQ_HBLANK);
	
#ifdef USE_WIFI
	irqSet(IRQ_WIFI, Wifi_Interrupt); // set up wifi interrupt
	irqEnable(IRQ_WIFI);
	
	{ // sync with arm9 and init wifi
  	u32 fifo_temp;   

	  while(1) { // wait for magic number
    	while(REG_IPC_FIFO_CR&IPC_FIFO_RECV_EMPTY) swiWaitForVBlank();
      fifo_temp=REG_IPC_FIFO_RX;
      if(fifo_temp==0x12345678) break;
   	}
   	while(REG_IPC_FIFO_CR&IPC_FIFO_RECV_EMPTY) swiWaitForVBlank();
   	fifo_temp=REG_IPC_FIFO_RX; // give next value to wifi_init
   	Wifi_Init(fifo_temp);
   	
   	irqSet(IRQ_FIFO_NOT_EMPTY,arm7_fifo); // set up fifo irq
   	irqEnable(IRQ_FIFO_NOT_EMPTY);
   	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_RECV_IRQ;

   	Wifi_SetSyncHandler(arm7_synctoarm9); // allow wifi lib to notify arm9
  } // arm7 wifi init complete
#endif

	// Keep the ARM7 idle
	while (1)
	{
		if (do_mp3 != 0)
		{
			char helix_argv1[100];
			char helix_argv2[100];
			memset(helix_argv1, 0, 100);
			memset(helix_argv2, 0, 100);
//			strcpy(helix_argv1, "/jones_orig.mp3");
//			sprintf(helix_argv1, "/quake soundtrack/0%d-AudioTrack 0%d.mp3", mp3_track_no, mp3_track_no);
//			strcpy(helix_argv2, "/jones.pcm");
			
			char *proper_helix_argv[3];
			proper_helix_argv[0] = NULL;
//			proper_helix_argv[1] = helix_argv1;
			proper_helix_argv[1] = (char *)track_name;
			proper_helix_argv[2] = helix_argv2;
			
			ARM7_PRINT("Starting Helix...\n");
			decoder_stopped = 0;
#ifdef USE_MP3
			helix_main(3, proper_helix_argv);
#endif
			decoder_stopped = 1;
			
			ARM7_PRINT("out of helix\n");
			do_mp3 = 0;
			
			while (quake_ipc_7to9->message == 0xffffffff);
			
			quake_ipc_7to9->message_type = kStopMP3;
			quake_ipc_7to9->message = 0xffffffff;
			
			while (quake_ipc_7to9->message == 0xffffffff);
			
			ARM7_PRINT("message sent\n");
		}
		
		swiWaitForVBlank();
	}
}


