/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// in_null.c -- for systems without a mouse

#include "quakedef.h"

extern "C" unsigned int keysDown(void);
extern "C" unsigned int keysUp(void);
extern "C" unsigned int keysHeld(void);

void debug_msg(char *);
void get_pen_pos(short *px, short *py);

void IN_Init (void)
{
}

void IN_Shutdown (void)
{
}

extern int mip_used;

void IN_Commands (void)
{
	unsigned int down = keysDown();
	unsigned int up = keysUp();
	
	if (down || up)
	{
		if ((down & 1) == 1)		//A
			Key_Event(K_ENTER, true);
		if ((up & 1) == 1)		//A
			Key_Event(K_ENTER, false);
			
		if ((down & 2) == 2)		//B
			Key_Event(K_ESCAPE, true);
		if ((up & 2) == 2)		//B
			Key_Event(K_ESCAPE, false);
		
		if ((down & 16) == 16)		//right
			Key_Event('d', true);
		if ((up & 16) == 16)		//right
			Key_Event('d', false);
		
		if ((down & 32) == 32)		//left
			Key_Event('a', true);
		if ((up & 32) == 32)		//left
			Key_Event('a', false);
		
		if ((down & 64) == 64)		//up
			Key_Event(K_UPARROW, true);
		if ((up & 64) == 64)		//up
		{
			Key_Event(K_UPARROW, false);
			Key_Event(K_UPARROW, false);
		}
		
		if ((down & 128) == 128)	//down
			Key_Event(K_DOWNARROW, true);
		if ((up & 128) == 128)		//down
		{
			Key_Event(K_DOWNARROW, false);
			Key_Event(K_DOWNARROW, false);
		}
			
	/*	if ((down & 256) == 256)	//R
			Key_Event(K_DOWNARROW, true);
		if ((up & 256) == 256)		//R
			Key_Event(K_DOWNARROW, false);*/
		
		if ((down/* & 256*/) == 256)
			Cbuf_AddText("god");
			
//		if ((down /*& 512*/) == 512)	//L
//		{
//			mip_used++;
//			if (mip_used == 4)
//				mip_used = 0;
//		}
		if ((down & 512) == 512)
			Key_Event(K_CTRL, true);
		if ((up & 512) == 512)		//L
			Key_Event(K_CTRL, false);
			
		if ((down & 1024) == 1024)
			Cbuf_AddText("impulse 10");
//		if ((up & 1024) == 1024)		//X
//			Key_Event(K_MWHEELDOWN, false);
			
		if ((down & 2048) == 2048)
			Cbuf_AddText("impulse 12");
//		if ((up & 2048) == 2048)		//X
//			Key_Event(K_MWHEELUP, false);
			
//		if ((down & 512) && (down & 256))
//		{
//			unsigned short *out;
//			extern unsigned short *frame_buffer_base;
//			extern int frame_buffer_width;
//			extern int frame_buffer_height;
//			extern unsigned char *my_palette;
//			
//			out = frame_buffer_base;
//			int x, y;
//			
//			printf("taking screenshot\n");
//			
//			unsigned char *fb = (unsigned char *)malloc(256 * 96 * 3);
//			if (fb == NULL)
//			{
//				printf("couldn\'t allocate ss buffer\n");
//				while(1);
//			}
//			for (y = 0; y < 96; y++)
//				for (x = 0; x < frame_buffer_width; x++)
//				{
//					unsigned char rendered_val = vid.buffer[y * 256 + x];
//					
//					fb[(y * frame_buffer_width + x) * 3+ 0] = my_palette[rendered_val * 3 + 0];
//					fb[(y * frame_buffer_width + x) * 3+ 1] = my_palette[rendered_val * 3 + 1];
//					fb[(y * frame_buffer_width + x) * 3+ 2] = my_palette[rendered_val * 3 + 2];
//				}
//			
//			char name[20];
//			sprintf(name, "/show%d.raw", mip_used);
//			printf("opening %s\n", name);
//			int handle = Sys_FileOpenWrite(name);
//			Sys_FileWrite(handle, fb, 256 * 96 * 3);
//			
//			free(fb);
//			
//			fb = (unsigned char *)malloc(256 * 96 * 3);
//			for (y = 96; y < frame_buffer_height; y++)
//				for (x = 0; x < frame_buffer_width; x++)
//				{
//					unsigned char rendered_val = vid.buffer[y * 256 + x];
//					
//					fb[((y - 96) * frame_buffer_width + x) * 3 + 0] = my_palette[rendered_val * 3 + 0];
//					fb[((y - 96) * frame_buffer_width + x) * 3 + 1] = my_palette[rendered_val * 3 + 1];
//					fb[((y - 96) * frame_buffer_width + x) * 3 + 2] = my_palette[rendered_val * 3 + 2];
//				}
//			Sys_FileWrite(handle, fb, 256 * 96 * 3);
//			
//			Sys_FileClose(handle);
//			
//			free(fb);
//			printf("done\n");
//		}
	}
}

short last_px = 128;
short last_py = 96;
void IN_Move (usercmd_t *cmd)
{
	short px, py;
	unsigned int down = keysHeld();
	get_pen_pos(&px, &py);

	if ((keysDown() & (1 << 12)) == (1 << 12))
	{
		last_px = px;
		last_py = py;
	}
	
	if ((down & 4096) == 4096)
	{
		/*if ((down & 256) == 256)
		{
			cmd->forwardmove -= (py - 96);
			cmd->sidemove += (px - last_px);
		}
		else*/
		{
			cl.viewangles[PITCH] += ((py - last_py) * 0.75f);
			cl.viewangles[YAW] -= ((px - last_px) * 0.75f);
		}
		
		V_StopPitchDrift();
	}

	last_px = px;
	last_py = py;
	
//	Sys_Printf("vel %.2f %.2f\n", cl.velocity[0], cl.velocity[1]);
	
//	if ((keysHeld() & (1 << 12)) == (1 << 12))
//		cl.viewangles[YAW] += 1;
}

