#ifndef QUAKE_IPC_H_
#define QUAKE_IPC_H_

enum IPCMessageType
{
	kPrintMessage,
	kPrintNumber,
	kInit,
	kMalloc,
	kFree,
	kStopAllSounds,
	kPlayMP3,
	kStopMP3,
	kFOpen,
	kFClose,
	kFRead
};

struct QuakeIPCRegion
{
	unsigned int message;
	unsigned int message_type;
};
volatile struct QuakeIPCRegion *quake_ipc_9to7 = (volatile struct QuakeIPCRegion *)0x2400000;
volatile unsigned char *quake_ipc_9to7_buf = 0;
volatile struct QuakeIPCRegion *quake_ipc_7to9 = (volatile struct QuakeIPCRegion *)0x2400000 + sizeof(struct QuakeIPCRegion);
volatile unsigned char *quake_ipc_7to9_buf = 0;

#define ARM7_PRINTF(args...) \
{\
	while(quake_ipc_7to9->message == 0xffffffff);\
	/*sprintf((char *)quake_ipc_7to9_buf, args);*/\
	quake_ipc_7to9->message_type = kPrintMessage;\
	quake_ipc_7to9->message = 0xffffffff;\
	while(quake_ipc_7to9->message == 0xffffffff);\
}\

#define ARM7_PRINT(string) \
{\
	while(quake_ipc_7to9->message == 0xffffffff);\
	memcpy((void *)quake_ipc_7to9_buf, string, strlen(string) + 1);\
	quake_ipc_7to9->message_type = kPrintMessage;\
	quake_ipc_7to9->message = 0xffffffff;\
	while(quake_ipc_7to9->message == 0xffffffff);\
}\

#define ARM7_PRINT_NUMBER(number) \
{\
	while(quake_ipc_7to9->message == 0xffffffff);\
	quake_ipc_7to9_buf[0] = number;\
	quake_ipc_7to9->message_type = kPrintNumber;\
	quake_ipc_7to9->message = 0xffffffff;\
	while(quake_ipc_7to9->message == 0xffffffff);\
}\

#endif /*QUAKE_IPC_H_*/
